﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Controllers
{
    public interface IMessageController
    {
        List<IMessage> GetLatestMessagesReceived(int maximumMessages = 40);
        List<IMessage> GetLatestMessagesSent(int maximumMessages = 40);

        // Publish Message
        IMessage PublishMessage(IMessageDTO messageDTO);
        IMessage PublishMessage(string text, IUser targetUser);
        IMessage PublishMessage(string text, IUserDTO targetUserDTO);
        IMessage PublishMessage(string text, long targetUserId);
        IMessage PublishMessage(string text, string targetUserScreenName);

        // Destroy Message
        bool DestroyMessage(IMessage message);
        bool DestroyMessage(IMessageDTO messageDTO);
        bool DestroyMessage(long messageId);
    }
}
