﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Controllers
{
    public interface ITimelineController
    {
        // Home Timeline
        List<ITweet> GetHomeTimeline(int maximumTweets = 40, bool excludeReplies = false);

        // User Timeline
        List<ITweet> GetUserTimeline(IUser user, int maximumTweets = 40, bool excludeReplies = false);
        List<ITweet> GetUserTimeline(IUserIdDTO userDTO, int maximumTweets = 40, bool excludeReplies = false);
        List<ITweet> GetUserTimeline(long userId, int maximumTweets = 40, bool excludeReplies = false);
        List<ITweet> GetUserTimeline(string userScreenName, int maximumTweets = 40, bool excludeReplies = false);

        // Mention Timeline
        List<IMention> GetMentionsTimeline(int maximumTweets = 40);
    }
}
