﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Controllers
{
    public interface ITweetController
    {
        // Publish Tweet
        ITweet PublishTweet(ITweet tweet);
        ITweet PublishTweet(ITweetDTO tweetDTO);

        // Publish Tweet in reply to
        ITweet PublishTweetInReplyTo(ITweet tweetToPublish, ITweet tweetToReplyTo);
        ITweet PublishTweetInReplyTo(ITweetDTO tweetToPublish, ITweetDTO tweetToReplyTo);
        ITweet PublishTweetInReplyTo(ITweetDTO tweet, long tweetIdToRespondTo);

        // Publish Retweet
        ITweet PublishRetweet(ITweet tweet);
        ITweet PublishRetweet(ITweetDTO tweetDTO);
        ITweet PublishRetweet(long tweetId);

        // Get Retweets
        List<ITweet> GetRetweets(ITweet tweet);
        List<ITweet> GetRetweets(ITweetDTO tweetDTO);
        List<ITweet> GetRetweets(long tweetId);

        // Destroy Tweet
        bool DestroyTweet(ITweet tweet);
        bool DestroyTweet(ITweetDTO tweetDTO);
        bool DestroyTweet(long tweetId);

        // Generate OembedTweet
        IOEmbedTweet GenerateOEmbedTweet(ITweet tweet);
        IOEmbedTweet GenerateOEmbedTweet(ITweetDTO tweetDTO);
        IOEmbedTweet GenerateOEmbedTweet(long tweetId);

        // Favorite Tweet
        bool FavoriteTweet(ITweet tweet, bool isFavorite);
        bool FavoriteTweet(ITweetDTO tweetDTO, bool isFavorite);
        bool FavoriteTweet(long tweetId, bool isFavorite);
    }
}
