﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Controllers
{
    public interface IUserController
    {
        // Friends
        List<long> GetFriendIds(IUser user, int maxFriendsToRetrieve = 5000);
        List<long> GetFriendIds(IUserIdDTO userDTO, int maxFriendsToRetrieve = 5000);

        List<IUser> GetFriends(IUser user, int maxFriendsToRetrieve = 250);
        List<IUser> GetFriends(IUserIdDTO userDTO, int maxFriendsToRetrieve = 250);

        // Followers
        List<long> GetFollowerIds(IUser user, int maxFriendsToRetrieve = 5000);
        List<long> GetFollowerIds(IUserIdDTO userDTO, int maxFollowersToRetrieve = 5000);

        List<IUser> GetFollowers(IUser user, int maxFollowersToRetrieve = 250);
        List<IUser> GetFollowers(IUserIdDTO userDTO, int maxFollowersToRetrieve = 250);

        // Favorites
        List<ITweet> GetFavoriteList(IUser user, int maxFavoritesToRetrieve = 40);
        List<ITweet> GetFavoriteList(IUserIdDTO userDTO, int maxFavoritesToRetrieve = 40);
        List<ITweet> GetFavoriteList(long userId, int maxFavoritesToRetrieve = 40);
        List<ITweet> GetFavoriteList(string userScreenName, int maxFavoritesToRetrieve = 40);
    }
}
