﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Factories
{
    public interface IFriendshipFactory
    {
        // Relationship
        IRelationship GetRelationshipBetween(IUser sourceUser, IUser targetUser);
        IRelationship GetRelationshipBetween(IUserDTO sourceUserDTO, IUserDTO targetUserDTO);

        IRelationship GetRelationshipBetween(long sourceUserId, long targetUserId);
        IRelationship GetRelationshipBetween(long sourceUserId, string targetUserScreenName);

        IRelationship GetRelationshipBetween(string sourceUserScreenName, string targetUserScreenName);
        IRelationship GetRelationshipBetween(string sourceUserScreenName, long targetUserId);

        // Get Relationships between the current user and a list of users
        Dictionary<IUser, IRelationshipState> GetRelationshipStatesAssociatedWith(List<IUser> targetUsers);

        List<IRelationshipState> GetRelationshipStatesWith(List<IUser> targetUsers);
        List<IRelationshipState> GetRelationshipStatesWith(List<IUserDTO> targetUsersDTO);
        List<IRelationshipState> GetRelationshipStatesWith(List<long> targetUsersId);
        List<IRelationshipState> GetRelationshipStatesWith(List<string> targetUsersScreenName);

        // Generate from DTO
        IRelationship GenerateRelationshipFromRelationshipDTO(IRelationshipDTO relationshipDTO);
        List<IRelationship> GenerateRelationshipsFromRelationshipsDTO(IEnumerable<IRelationshipDTO> relationshipDTO);
    }
}
