﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Factories
{
    public interface IMessageFactory
    {
        // Get existing message
        IMessage GetExistingMessage(long messageId);

        // Create message
        IMessage CreateMessage(string text, IUser recipient = null);

        // Generate message from DTO
        IMessage GenerateMessageFromMessageDTO(IMessageDTO messageDTO);
        List<IMessage> GenerateMessagesFromMessagesDTO(IEnumerable<IMessageDTO> messagesDTO);
    }
}
