﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;

namespace TweetinCore.Interfaces.Factories
{
    public interface ITweetFactory
    {
        ITweet GetTweet(long tweetId);
        ITweet CreateTweet(string text);

        // Generate Tweet from DTO
        ITweet GenerateTweetFromDTO(ITweetDTO tweetDTO);
        List<ITweet> GenerateTweetsFromDTO(List<ITweetDTO> tweetsDTO);

        // Generate OEmbedTweet from DTO
        IOEmbedTweet GenerateOEmbedTweetDTO(IOEmbedTweetDTO oEmbedTweetDTO);

        // Generate Mention from DTO
        IMention GenerateMentionFromDTO(ITweetDTO tweetDTO);
        List<IMention> GenerateMentionsFromDTO(IEnumerable<ITweetDTO> tweetsDTO);
    }
}
