﻿using System.Collections.Generic;
using TweetinCore.Interfaces.DTO;
using TweetinCore.Interfaces.TwitterToken;

namespace TweetinCore.Interfaces.Factories
{
    public interface IUserFactory
    {
        ITokenUser GetCurrentUser();

        IUser GetUserFromId(long userId);
        IUser GetUserFromScreenName(string userName);
        List<IUser> GetUsersFromIds(List<long> userIds);
        List<IUser> GetUsersFromNames(List<string> userNames);

        // Generate user from DTO
        IUser GenerateUserFromDTO(IUserDTO userDTO);
        ITokenUser GenerateTokenUserFromDTO(IUserDTO userDTO);
        List<IUser> GenerateUsersFromDTO(IEnumerable<IUserDTO> usersDTO);

        // Generate userIdDTO from
        IUserIdDTO GenerateUserIdDTOFromId(long userId);
        IUserIdDTO GenerateUserIdDTOFromScreenName(string userScreenName);
    }
}
