﻿using System;
using Newtonsoft.Json;
using TweetinCore.Interfaces.DTO;

namespace Tweetinvi.DTO
{
    public class UserIdDTO : IUserIdDTO
    {
        private long? _id;
        public long Id
        {
            get
            {
                if (_id == null)
                {
                    _id = IdStr == null ? -1 : Int64.Parse(IdStr);
                }

                return _id.Value;
            }
            set
            {
                _id = value;
                IdStr = _id.ToString();
            }
        }

        [JsonProperty("id_str")]
        public string IdStr { get; set; }

        [JsonProperty("screen_name")]
        public string ScreenName { get; set; }

        public bool HasAValidId()
        {
            return _id != null && _id != -1 && !String.IsNullOrEmpty(ScreenName);
        }
    }
}
