﻿using System.Collections.Generic;
using Newtonsoft.Json;
using TweetinCore.Interfaces;
using Tweetinvi.Model;

namespace Tweetinvi
{
    /// <summary>
    /// Geographic information of a location
    /// </summary>
    public class Geo : IGeo
    {
        private List<double> _geoCoordinates;

        [JsonProperty("type")]
        public string Type { get; set; }

        // ReSharper disable once InconsistentNaming
        [JsonProperty("coordinates")]
        private List<double> _coordinatesSetter
        {
            get { return _geoCoordinates; }
            set
            {
                _geoCoordinates = value;
                if (_geoCoordinates != null)
                {
                    Coordinates = new Coordinates(_geoCoordinates[1], _geoCoordinates[0]);
                }
            }
        }

        public ICoordinates Coordinates { get; set; }
    }
}
