﻿using System;
using System.Collections.Generic;
using System.Linq;
using Newtonsoft.Json;
using TweetinCore.Interfaces;
using Tweetinvi.Model;

namespace Tweetinvi.JsonConverters
{
    internal class JsonTwitterCoordinatesConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            throw new NotImplementedException();
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            if (reader.Value == null)
            {
                return new Coordinates();
            }

            IEnumerable<double> coordinates = serializer.Deserialize<IEnumerable<double>>(reader);

            if (coordinates == null || !coordinates.Any())
            {
                return null;
            }

            return new Coordinates(coordinates.ElementAt(0), coordinates.ElementAt(1));
        }

        public override bool CanConvert(Type objectType)
        {
            return (objectType == typeof(ICoordinates));
        }
    }
}
