﻿using System;
using System.Collections.Generic;
using TweetinCore.Extensions;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.Controllers;
using TweetinCore.Interfaces.DTO;
using TweetinCore.Interfaces.Factories;
using TweetinCore.Interfaces.TwitterToken;
using Tweetinvi.Helpers;

namespace Tweetinvi
{
    /// <summary>
    /// Twitter mention
    /// </summary>
    public class Mention : Tweet, IMention
    {
        #region Private Attributes

        private string _annotations;
        
        #endregion

        #region Public Attributes
        
        public string Annotations
        {
            get { return _annotations; }
            set { _annotations = value; }
        }
        
        #endregion

        /// <summary>
        /// Default constructor
        /// </summary>
        public Mention(
            ITweetDTO tweetDTO,
            ITweetController tweetController,
            ITweetFactory tweetFactory,
            IUserFactory userFactory) 
                
                : base(tweetDTO,
                       tweetController,
                       tweetFactory,
                       userFactory)
        {
            // Default constructor inheriting from the default Tweet constructor
        }
    }
}