﻿using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Unity;
using TweetinCore.Helpers;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.TwitterToken;
using TweetinCore.Wrappers;
using Tweetinvi.JsonConverters;
using Tweetinvi.TwitterEntities;
using Tweetinvi.Wrapper;

namespace Tweetinvi
{
    public class TweetinviModule : IModule
    {
        private readonly IUnityContainer _container;

        public TweetinviModule(IUnityContainer container)
        {
            _container = container;
        }

        public void Initialize()
        {
            _container.RegisterType<ITweet, Tweet>();
            _container.RegisterType<IOEmbedTweet, OEmbedTweet>();
            _container.RegisterType<IUser, User>();
            _container.RegisterType<ITokenUser, TokenUser>();
            _container.RegisterType<IMessage, Message>();
            _container.RegisterType<IMention, Mention>();
            _container.RegisterType<IRelationship, Relationship>();
            _container.RegisterType<IRelationshipState, RelationshipState>();
            _container.RegisterType<IJsonPropertyConverterRepository, JsonPropertyConverterRepository>();

            InitializeWrappers();
        }

        private void InitializeWrappers()
        {
            _container.RegisterType<IJObjectWrapper, JObjectWrapper>();
            _container.RegisterType<IJsonConvertWrapper, JsonConvertWrapper>();
        }
    }
}
