﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.Factories;
using TweetinCore.Interfaces.TwitterToken;

namespace TweetinviBootstrapper.Message
{
    public static class MessageCreator
    {
         private static readonly IMessageFactory _messageFactory;

         static MessageCreator()
        {
            var container = TweetinviFactoriesBootstrapper.Container;
            _messageFactory = container.Resolve<IMessageFactory>();

            TwitterAccessor = TwitterCredentials.TwitterAccessor;
        }

        public static ITwitterAccessor TwitterAccessor { get; set; }

        public static IMessage GetExistingMessage(long messageId)
        {
            return _messageFactory.GetExistingMessage(messageId);
        }

        public static IMessage CreateMessage(string text, IUser recipient = null)
        {
            return _messageFactory.CreateMessage(text, recipient);
        }
    }
}
