﻿using System.Collections.Generic;
using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.Controllers;
using TweetinCore.Interfaces.DTO;

namespace TweetinviBootstrapper.Timeline
{
    public static class TimelineController
    {
        private static readonly ITimelineController _timelineController;

        static TimelineController()
        {
            var containter = TweetinviFactoriesBootstrapper.Container;
            _timelineController = containter.Resolve<ITimelineController>();
        }

        // Home Timeline
        public static List<ITweet> GetHomeTimeline(int maximumTweets = 40, bool excludeReplies = false)
        {
            return _timelineController.GetHomeTimeline(maximumTweets, excludeReplies);
        }

        // User Timeline
        public static List<ITweet> GetUserTimeline(IUser user, int maximumTweets = 40, bool excludeReplies = false)
        {
            return _timelineController.GetUserTimeline(user, maximumTweets, excludeReplies);
        }

        public static List<ITweet> GetUserTimeline(IUserDTO userDTO, int maximumTweets = 40, bool excludeReplies = false)
        {
            return _timelineController.GetUserTimeline(userDTO, maximumTweets, excludeReplies);
        }

        public static List<ITweet> GetUserTimeline(long userId, int maximumTweets = 40, bool excludeReplies = false)
        {
            return _timelineController.GetUserTimeline(userId, maximumTweets, excludeReplies);
        }

        public static List<ITweet> GetUserTimeline(string userScreenName, int maximumTweets = 40, bool excludeReplies = false)
        {
            return _timelineController.GetUserTimeline(userScreenName, maximumTweets, excludeReplies);
        }

        // Mention Timeline
        public static List<IMention> GetMentionsTimeline(int maximumTweets = 40)
        {
            return _timelineController.GetMentionsTimeline(maximumTweets);
        }
    }
}
