﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.DTO;
using TweetinCore.Interfaces.Factories;
using TweetinCore.Interfaces.TwitterToken;

namespace TweetinviBootstrapper.Tweet
{
    public static class TweetCreator
    {
        private static readonly ITweetFactory _tweetFactory;

        static TweetCreator()
        {
            var container = TweetinviFactoriesBootstrapper.Container;
            _tweetFactory = container.Resolve<ITweetFactory>();

            TwitterAccessor = TwitterCredentials.TwitterAccessor;
        }

        public static ITwitterAccessor TwitterAccessor { get; set; }

        public static ITweet GetTweet(long tweetId)
        {
            return _tweetFactory.GetTweet(tweetId);
        }

        public static ITweet CreateTweet(string text)
        {
            return _tweetFactory.CreateTweet(text);
        }

        public static ITweet GenerateTweetFromDTO(ITweetDTO tweetDTO)
        {
            return _tweetFactory.GenerateTweetFromDTO(tweetDTO);
        }
    }
}
