﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces.TwitterToken;

namespace TweetinviBootstrapper
{
    public class TwitterCredentials
    {
        private static readonly ITwitterAccessor _twitterAccessor;

        static TwitterCredentials()
        {
            var container = TweetinviFactoriesBootstrapper.Container;

            _twitterAccessor = container.Resolve<ITwitterAccessor>();
        }

        public static ITwitterAccessor TwitterAccessor
        {
            get { return _twitterAccessor; }
        }

        public static ITokenCredentials TokenCredentials
        {
            get { return _twitterAccessor.TwitterCredentials; }
            set { _twitterAccessor.TwitterCredentials = value; }
        }
    }
}
