﻿using System.Collections.Generic;
using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.Controllers;
using TweetinCore.Interfaces.DTO;
using TweetinCore.Interfaces.TwitterToken;

namespace TweetinviBootstrapper.User
{
    public static class UserController
    {
        private static readonly IUserController _userController;

        static UserController()
        {
            var container = TweetinviFactoriesBootstrapper.Container;
            _userController = container.Resolve<IUserController>();

            TwitterAccessor = TwitterCredentials.TwitterAccessor;
        }

        public static ITwitterAccessor TwitterAccessor { get; set; }

        // Friends
        public static List<long> GetFriendIds(IUser user, int maxFriendsToRetrieve = 5000)
        {
            return _userController.GetFriendIds(user, maxFriendsToRetrieve);
        }

        public static List<long> GetFriendIds(IUserDTO userDTO, int maxFriendsToRetrieve = 5000)
        {
            return _userController.GetFriendIds(userDTO, maxFriendsToRetrieve);
        }

        public static List<IUser> GetFriends(IUser user, int maxFriendsToRetrieve = 250)
        {
            return _userController.GetFriends(user, maxFriendsToRetrieve);
        }

        public static List<IUser> GetFriends(IUserDTO userDTO, int maxFriendsToRetrieve = 250)
        {
            return _userController.GetFriends(userDTO, maxFriendsToRetrieve);
        }

        // Followers
        public static List<long> GetFollowerIds(IUser user, int maxFollowersToRetrieve = 5000)
        {
            return _userController.GetFollowerIds(user, maxFollowersToRetrieve);
        }

        public static List<long> GetFollowerIds(IUserDTO userDTO, int maxFollowersToRetrieve = 5000)
        {
            return _userController.GetFollowerIds(userDTO, maxFollowersToRetrieve);
        }

        public static List<IUser> GetFollowers(IUser user, int maxFollowersToRetrieve = 250)
        {
            return _userController.GetFollowers(user, maxFollowersToRetrieve);
        }

        public static List<IUser> GetFollowers(IUserDTO userDTO, int maxFollowersToRetrieve = 250)
        {
            return _userController.GetFollowers(userDTO, maxFollowersToRetrieve);
        }
    }
}
