﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.Factories;
using TweetinCore.Interfaces.TwitterToken;

namespace TweetinviBootstrapper.User
{
    public static class UserCreator
    {
        private static readonly IUserFactory _userFactory;

        static UserCreator()
        {
            var container = TweetinviFactoriesBootstrapper.Container;
            _userFactory = container.Resolve<IUserFactory>();

            TwitterAccessor = TwitterCredentials.TwitterAccessor;
        }

        public static ITwitterAccessor TwitterAccessor { get; set; }

        public static ITokenUser GetCurrentUser()
        {
            return _userFactory.GetCurrentUser();
        }

        public static IUser GetUserFromId(long userId)
        {
            return _userFactory.GetUserFromId(userId);
        }

        public static IUser GetUserFromScreenName(string userName)
        {
            return _userFactory.GetUserFromScreenName(userName);
        }
    }
}
