﻿using System;
using System.Globalization;
using TweetinCore.Interfaces;

namespace TweetinviControllers.Tweet
{
    public interface ITweetQueryGenerator
    {
        string GeneratePlaceIdParameter(string placeId);
        string GenerateGeoParameter(ICoordinates coordinates);
    }

    public class TweetQueryGenerator : ITweetQueryGenerator
    {
        public string GeneratePlaceIdParameter(string placeId)
        {
            if (String.IsNullOrEmpty(placeId))
            {
                return null;
            }

            return String.Format("&place_id={0}", placeId);
        }

        public string GenerateGeoParameter(ICoordinates coordinates)
        {
            if (coordinates == null)
            {
                return null;
            }

            string latitudeValue = coordinates.Latitude.ToString(CultureInfo.InvariantCulture);
            string longitudeValue = coordinates.Longitude.ToString(CultureInfo.InvariantCulture);

            return String.Format("&long={0}&lat={1}", longitudeValue, latitudeValue);
        }
    }
}
