﻿using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Unity;
using TweetinCore.Interfaces.Controllers;
using TweetinCore.Interfaces.QueryGenerators;
using TweetinviControllers.Direct_Messages;
using TweetinviControllers.Friendship;
using TweetinviControllers.Timeline;
using TweetinviControllers.Tweet;
using TweetinviControllers.User;

namespace TweetinviControllers
{
    public class TweetinviControllersModule : IModule
    {
        private readonly IUnityContainer _container;

        public TweetinviControllersModule(IUnityContainer container)
        {
            _container = container;
        }

        public void Initialize()
        {
            _container.RegisterType<ITweetController, TweetController>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IUserController, UserController>(new ContainerControlledLifetimeManager());
            _container.RegisterType<ITimelineController, TimelineController>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IMessageController, MessageController>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IFriendshipController, FriendshipController>(new ContainerControlledLifetimeManager());

            _container.RegisterType<ITweetQueryExecutor, TweetQueryExecutor>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IUserQueryExecutor, UserQueryExecutor>(new ContainerControlledLifetimeManager());
            _container.RegisterType<ITimelineQueryExecutor, TimelineQueryExecutor>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IMessageQueryExecutor, MessageQueryExecutor>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IFriendshipQueryExecutor, FriendshipQueryExecutor>();

            _container.RegisterType<ITweetQueryGenerator, TweetQueryGenerator>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IUserQueryGenerator, UserQueryGenerator>(new ContainerControlledLifetimeManager());
        }
    }
}
