﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.TwitterToken;
using TweetinviFactories.Tweet;

namespace TweetinviFactories
{
    public static class TweetCreator
    {
        private static readonly ITweetFactory _tweetFactory;

        static TweetCreator()
        {
            var container = TweetinviFactoriesBootstrapper.Container;
            _tweetFactory = container.Resolve<ITweetFactory>();

            Token = TwitterCredentials.Token;
        }

        public static IToken Token { get; set; }

        public static ITweet GetTweet(long tweetId)
        {
            return _tweetFactory.GetTweet(tweetId);
        }

        public static ITweet CreateTweet(string text)
        {
            return _tweetFactory.CreateTweet(text);
        }
    }
}
