﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces;
using TweetinCore.Interfaces.DTO;

namespace TweetinviFactories
{
    internal interface ITweetFactory
    {
        ITweet CreateTweetFromJson(ITweetDTO tweetObject);
    }

    internal class TweetFactory : ITweetFactory
    {
        private readonly IUnityContainer _container;

        public TweetFactory(IUnityContainer container)
        {
            _container = container;
        }

        public ITweet CreateTweetFromJson(ITweetDTO tweetObject)
        {
            var tweet = _container.Resolve<ITweet>(new ResolverOverride[]
            {
                new ParameterOverride("tweetObject", tweetObject)
            });

            return tweet;
        }
    }
}
