﻿using Microsoft.Practices.Unity;
using TweetinCore.Interfaces.Factories;

namespace TweetinviFactories
{
    public class UnityFactory<T> : IUnityFactory<T>
    {
        private readonly IUnityContainer _container;

        public UnityFactory(IUnityContainer container)
        {
            _container = container;
        }

        public T Create()
        {
            return _container.Resolve<T>();
        }

        public T Create(ResolverOverride[] resolver)
        {
            return _container.Resolve<T>(resolver);
        }
    }
}
