﻿using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Unity;
using TweetinCore.Interfaces.TwitterToken;

namespace TwitterToken
{
    public class TwitterTokenModule : IModule
    {
        private readonly IUnityContainer _container;

        public TwitterTokenModule(IUnityContainer container)
        {
            _container = container;
        }

        public void Initialize()
        {
            _container.RegisterType<IToken, Token>(new ContainerControlledLifetimeManager());
            // To replace Token
            _container.RegisterType<ITwitterAccessor, TwitterAccessor>(new ContainerControlledLifetimeManager());

            _container.RegisterType<ITokenCreator, TokenCreator>();
            _container.RegisterType<ITokenCredentials, TokenCredentials>();
            _container.RegisterType<ITokenRateLimits, TokenRateLimits>();
        }
    }
}
