﻿using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Unity;
using TweetinCore.Interfaces.oAuth;

namespace oAuthConnection
{
    public class OAuthConnectionModule : IModule
    {
        private readonly IUnityContainer _container;

        public OAuthConnectionModule(IUnityContainer container)
        {
            _container = container;
        }

        public void Initialize()
        {
            _container.RegisterType<IOAuthToken, OAuthToken>();
            _container.RegisterType<IOAuthCredentials, OAuthCredentials>();

            _container.RegisterType<IOAuthQueryParameter, OAuthQueryParameter>();
            _container.RegisterType<IOAuthWebRequestGenerator, OAuthWebRequestGenerator>();
        }
    }
}
